package com.junmp.jyzb.api.bean.query;

import com.baomidou.mybatisplus.annotation.TableField;
import com.junmp.v2.common.bean.request.BaseRequest;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.util.List;

@Data
@EqualsAndHashCode(callSuper = true)
public class CabinetBoxReq extends BaseRequest {
    /**
     * 主键ID
     */
    @ApiModelProperty(value = "主键ID")
    @NotBlank(message = "箱门id不能为空",groups = {detail.class})
    private String id;

    /**
     * 主柜ID
     */
    @ApiModelProperty(value = "主柜ID")
    private String cabinetId;

    /**
     * 箱号
     */
    @ApiModelProperty(value = "箱号")
    private Integer num;

    /**
     * 异常状态:1正常/0异常
     */
    @ApiModelProperty(value = "异常状态:1正常/0异常")
    private Integer state;

    /**
     * 异常原因
     */
    @ApiModelProperty(value = "异常原因")
    private String errorMsg;

    /**
     * 使用日志存储位置信息
     */
    @ApiModelProperty(value = "使用日志存储位置信息")
    private String logMap;

    /**
     * 警员id
     */

    @ApiModelProperty(value = "警员id")
    private String policeId;

    /**
     * 箱门类型：1单警柜，2公共柜
     */

    @ApiModelProperty(value = "箱门类型：1单警柜，2公共柜")
    private Integer containType;

    private String cabinetName;

    private static final long serialVersionUID = 1L;
}