package com.junmp.jyzb.api.bean.req;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.junmp.v2.common.bean.request.BaseRequest;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 个人装备移交、报废、维修的子单据请求实体类
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class BaseOrderItemReq extends BaseRequest {
    /**
     * 子单据id
     */
    private Long id;

    /**
     * 主单据id
     */
    private String orderId;

    /**
     * 装备号型id
     */
    private String sizeId;

    /**
     * 号型名称
     */
    private String sizeName;

    /**
     * 类型id
     */
    private String typeId;

    /**
     * 类型名称
     */
    private String typeName;

    /**
     * 供应商id
     */
    private String supplierId;

    /**
     * 供应商名称
     */
    private String supplierName;

    /**
     * 价格
     */
    private BigDecimal price;

    /**
     * 数量
     */
    private Integer num;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 更新时间
     */
    private Date updateTime;

    /**
     * 创建人员
     */
    private String createUser;

    /**
     * 更新人员
     */
    private String updateUser;
}
